﻿package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.utils.setInterval;
	//import flash.display.CapsStyle;

	public class Liner extends Sprite
	{
		public var balls:Array
		public function Liner()
		{
			balls = new Array();
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
			}
		
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			setInterval(buildScreen,10);
			stage.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		private function fullhandler(e:FullScreenEvent):void
		{
			balls = new Array();
		}
		private function clickHandler(e:MouseEvent):void
		{
			var pt:Point = new Point(e.stageX,e.stageY);
			var obj:Object = {"posx":this.globalToLocal(pt).x,"posy":this.globalToLocal(pt).y,"angle":0,"rayon":(Math.round(100)),"centerY":this.globalToLocal(pt).y};
			balls.push(obj);
			balls.sortOn(["posx"],[Array.NUMERIC]);
		}
		
		private function buildScreen():void
		{
			//graphics.beginFill(0xffffff,0);
			//graphics.drawRect(0,0,stage.stageWidth, stage.stageHeight);
			this.graphics.clear();
			for(var i:Number = 0;i<balls.length;i++){
				graphics.drawCircle(balls[i].posx,balls[i].posy,0);
				graphics.endFill();
				graphics.lineStyle(4,0x00FAFA,0.4);
				//draw the lines
				if(i>0){
					graphics.beginFill(0x000000,0.3);
					graphics.moveTo(balls[i-1].posx,balls[i-1].posy);
					graphics.lineTo(balls[i].posx,balls[i].posy);
//					graphics.lineTo(balls[i].posx*(Math.tan(i)),balls[i].posy*(Math.tan(i)));
					graphics.lineTo(balls[i].angle*(Math.atan(i))+stage.stageWidth/2,balls[i].angle*(Math.atan(i))+stage.stageHeight/2);
				}
				graphics.lineStyle();
				//set the new position
//				balls[i].posy = balls[i].centerY + Math.sin(balls[i].angle*Math.PI/180)*balls[i].rayon;
				balls[i].posy = balls[i].centerY + Math.atan(balls[i].angle*Math.PI/180)*balls[i].rayon;
				balls[i].angle++;
			}
		}
	}
}